// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef NETWORK_INTERFACE_HH
#define NETWORK_INTERFACE_HH

#include <stdint.h>
#include <systemc>

class network_interface :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > clk;
    sc_core::sc_in< bool > reset;
    sc_core::sc_in< bool > mode;
    sc_core::sc_out< bool > rx_data_ready;
    sc_core::sc_out< uint32_t > rx_data;
    sc_core::sc_in< bool > tx_data_ready;
    sc_core::sc_in< uint32_t > tx_data;
    sc_core::sc_out< bool > tx_data_done;
    sc_core::sc_signal< bool > net_data_available;
    sc_core::sc_signal< bool > net_data_sent;
    sc_core::sc_signal< uint32_t > net_data_incoming;
    sc_core::sc_signal< uint32_t > net_data_outgoing;
    sc_core::sc_signal< bool > clkSuphif_2;


    SC_HAS_PROCESS( network_interface );

    network_interface( sc_core::sc_module_name name_ );
    ~network_interface();


private:

    network_interface( const network_interface & );
    const network_interface& operator= ( const network_interface & );


    void vhdl_process();
    void UpdclkSuphif_2();

};


#endif

